package cn.unitid.matrix.pkiservice.test.ces;

import cn.unitid.matrix.pkiservice.sdk.ApiException;
import cn.unitid.matrix.pkiservice.sdk.PkiClient;
import cn.unitid.matrix.pkiservice.sdk.PkiOkhttpClient;
import cn.unitid.matrix.pkiservice.sdk.ces.request.AsymmetricEncryptRequest;
import cn.unitid.matrix.pkiservice.sdk.ces.response.AsymmetricEncryptResponse;
import cn.unitid.matrix.pkiservice.sdk.consts.CertSearchEnum;
import cn.unitid.matrix.pkiservice.sdk.consts.DataType;
import cn.unitid.matrix.pkiservice.sdk.consts.KeypairTypeEnum;

/**
 * 非对称公钥加密
 */
public class AsymmetricEncryptTest {

    public static void main(String[] args) {
        // 提供的URL
        String url = "http://172.16.3.232:25115";

        // 您的appKey
        String appKey = "eB4P623i5h";

        // 您的appSecret
        String appSecret = "RzToiB0vzP6hnWd0Rt8u3Om2RDL0YHAA";

        // 原客户端
        PkiClient pkiClient = new PkiOkhttpClient(url, appKey, appSecret);


        AsymmetricEncryptRequest request = new AsymmetricEncryptRequest();

        String data = "MTIz";

        request.setEncryptType(CertSearchEnum.CERT_ID);

        // 签名项目的值
        request.setEncryptItemValue("628cb99a51cfb422619db668");

        // 待加密数据
        request.setData(data);

        // 待加密数据类型
        request.setDataType(DataType.BASE64);

        // 加密数据后数据格式
        request.setEncryptDataType(DataType.BASE64);

        // 用加密密钥 加密
        request.setKeyType(KeypairTypeEnum.ENCRYPT);

        try {
            AsymmetricEncryptResponse response = pkiClient.execute(request);
            // 后续业务
            if (response.isSuccess()) {
                System.out.println("成功：" + response.getResult());
            } else {
                System.out.println("失败：" + response.getBody());
            }
        } catch (ApiException e) {
            e.printStackTrace();
        }
    }
}
