package cn.unitid.matrix.pkiservice.test.ces;

import cn.unitid.matrix.pkiservice.sdk.ApiException;
import cn.unitid.matrix.pkiservice.sdk.PkiClient;
import cn.unitid.matrix.pkiservice.sdk.PkiOkhttpClient;
import cn.unitid.matrix.pkiservice.sdk.ces.request.P1SignRequest;
import cn.unitid.matrix.pkiservice.sdk.ces.response.P1SignResponse;
import cn.unitid.matrix.pkiservice.sdk.consts.CertSearchEnum;
import cn.unitid.matrix.pkiservice.sdk.consts.DataType;
import cn.unitid.matrix.pkiservice.sdk.consts.SignatureAlgorithm;

/**
 * P1签名
 */
public class P1SignTest {

    public static void main(String[] args) {
        // 提供的URL
        String url = "http://172.16.3.232:25115";

        // 您的appKey
        String appKey = "eB4P623i5h";

        // 您的appSecret
        String appSecret = "RzToiB0vzP6hnWd0Rt8u3Om2RDL0YHAA";

        // 1.原客户端
        PkiClient pkiClient = new PkiOkhttpClient(url, appKey, appSecret);

        String certId = "628cb99a51cfb422619db668";

        String data = "MTIz";

        P1SignRequest request = new P1SignRequest();

        //通过何种方式进行签名 CERT_ID：证书ID，KEY_INDEX：密钥索引， SN_HEX：证书序列号(十六进制格式)，SN_DEC：证书序列号(十进制格式)，TN_HASH：证书证书指纹，CERT_CN：证书CN ，CERT_DN：证书主题项(DN)
        request.setSignType(CertSearchEnum.CERT_ID);
        //签名项目的值
        request.setSignItemValue(certId);
        // 签名数据
        request.setData(data);
        //签名项目的值
        request.setDataType(DataType.BASE64);
        // 摘要算法，SM2证书签名固定为SM3，RSA默认SHA256
        request.setSignatureAlgorithm(SignatureAlgorithm.SM3withSM2);
        // 签名后数据格式
        request.setSignDataType(DataType.BASE64);

        try {
            P1SignResponse response = pkiClient.execute(request);
            // 后续业务
            if (response.isSuccess()) {
                System.out.println("成功响应：" + response.getResult());
            } else {
                System.out.println("失败响应：" + response.getBody());
            }
        } catch (ApiException e) {
            e.printStackTrace();
        }

    }
}
