package cn.unitid.matrix.pkiservice.test.ces;

import cn.unitid.matrix.pkiservice.sdk.ApiException;
import cn.unitid.matrix.pkiservice.sdk.PkiClient;
import cn.unitid.matrix.pkiservice.sdk.PkiOkhttpClient;
import cn.unitid.matrix.pkiservice.sdk.ces.request.AsymmetricDecryptRequest;
import cn.unitid.matrix.pkiservice.sdk.ces.request.SymmetricDecryptRequest;
import cn.unitid.matrix.pkiservice.sdk.ces.response.AsymmetricDecryptResponse;
import cn.unitid.matrix.pkiservice.sdk.ces.response.SymmetricDecryptResponse;
import cn.unitid.matrix.pkiservice.sdk.consts.CertSearchEnum;
import cn.unitid.matrix.pkiservice.sdk.consts.DataType;

/**
 * 对称密钥解密
 */
public class SymmetricDecryptTest {

    public static void main(String[] args) {
        // 提供的URL
        String url = "http://172.16.3.232:25115";

        // 您的appKey
        String appKey = "eB4P623i5h";

        // 您的appSecret
        String appSecret = "RzToiB0vzP6hnWd0Rt8u3Om2RDL0YHAA";

        // 原客户端
        PkiClient pkiClient = new PkiOkhttpClient(url, appKey, appSecret);


        SymmetricDecryptRequest request = new SymmetricDecryptRequest();

        Integer virtualIndex = 22009;

        String data = "WsdFW9g3chpvnq7dsB5jwQ==";

        // 解密依赖项的值
        request.setVirtualIndex(virtualIndex);

        // 解密依赖项的值
        request.setData(data);

        request.setDataType(DataType.BASE64);

        // 加密类型 签名密钥对解密、加密密钥对解密
        request.setDecryptDataType(DataType.BASE64);

        try {
            SymmetricDecryptResponse response = pkiClient.execute(request);
            // 后续业务
            if (response.isSuccess()) {
                System.out.println("成功：" + response.getResult());
            } else {
                System.out.println("失败：" + response.getBody());
            }
        } catch (ApiException e) {
            e.printStackTrace();
        }
    }
}
